> For the complete documentation index, see [llms.txt](https://docs.rome.builders/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rome.builders/ru/rukovodstva-dlya-razrabotchikov/websocket-subscriptions.md).

# Подписки WebSocket

Конечные точки Rome EVM поддерживают подписки Ethereum WebSocket (`eth_subscribe` / `eth_unsubscribe`) через `wss://`. Подключайтесь к тому же хосту, что и HTTPS RPC, используя `wss://` схему:

```
wss://<chain>.<network>.romeprotocol.xyz/
```

Именно это `ethers` / `viem` `WebSocketProvider` используют под капотом, поэтому `.on('block')`, `contract.on(event)`, и `viem`'s `watchEvent` / `watchBlocks` работают без дополнительной настройки.

## Типы подписок

| Тип                      | Срабатывает при                             | Используется для                                                                                |
| ------------------------ | ------------------------------------------- | ----------------------------------------------------------------------------------------------- |
| `newHeads`               | каждом новом блоке                          | обновления по блокам, обновление балансов/nonce, боты, работающие по каждому блоку, индексаторы |
| `логи`                   | совпадающие события (по `адресу` / `темам`) | реагирование на события вашего контракта, ретрансляторы/мосты, торговые боты                    |
| `newPendingTransactions` | —                                           | принимается, но никогда не эмитируется (у Rome нет публичного мемпула)                          |

## ethers (v6)

```javascript
import { ethers } from "ethers";

const provider = new ethers.WebSocketProvider(
  "wss://martius.testnet.romeprotocol.xyz/"
);

// newHeads
provider.on("block", (blockNumber) => {
  console.log("new block", blockNumber);
});

// logs — реагирование на событие контракта
const contract = new ethers.Contract(address, abi, provider);
contract.on("Transfer", (from, to, value) => {
  console.log("Transfer", from, to, value.toString());
});
```

## viem

```javascript
import { createPublicClient, webSocket } from "viem";

const client = createPublicClient({
  transport: webSocket("wss://martius.testnet.romeprotocol.xyz/"),
});

const unwatch = client.watchBlocks({
  onBlock: (block) => console.log("новый блок", block.number),
});

client.watchEvent({
  address,
  onLogs: (logs) => console.log(logs),
});
```

## Исходный JSON-RPC

```json
→ {"jsonrpc":"2.0","id":1,"method":"eth_subscribe","params":["newHeads"]}
← {"jsonrpc":"2.0","id":1,"result":"0x…"}                       // идентификатор подписки
← {"jsonrpc":"2.0","method":"eth_subscription","params":{"subscription":"0x…","result":{…block…}}}
```

Для `логи`, передайте объект фильтра вторым параметром:

```json
{"jsonrpc":"2.0","id":1,"method":"eth_subscribe","params":["logs",{"address":"0x…","topics":["0x…"]}]}
```

## Примечания

* Подписки отправляют обновления по мере формирования новых блоков (задержка сопоставима со временем блока).
* Для долгоживущих соединений обрабатывайте переподключения на стороне клиента — это стандартная практика для любого WebSocket RPC.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.rome.builders/ru/rukovodstva-dlya-razrabotchikov/websocket-subscriptions.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
